{-
	Copyright (C) 2011 Dr. Alistair Ward

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
-}
{- |
 [@AUTHOR@]	Dr. Alistair Ward

 [@DESCRIPTION@]	Calls the /quickChecks/-functions for modules supporting this feature.
-}

module Factory.Test.QuickCheck.QuickChecks(
-- * Functions
	run
) where

import qualified	Control.Arrow
import qualified	Factory.Test.QuickCheck.ArithmeticGeometricMean
import qualified	Factory.Test.QuickCheck.Factorial
import qualified	Factory.Test.QuickCheck.Hyperoperation
import qualified	Factory.Test.QuickCheck.Interval
import qualified	Factory.Test.QuickCheck.MonicPolynomial
import qualified	Factory.Test.QuickCheck.PerfectPower
import qualified	Factory.Test.QuickCheck.Pi
import qualified	Factory.Test.QuickCheck.Polynomial
import qualified	Factory.Test.QuickCheck.Power
import qualified	Factory.Test.QuickCheck.Primality
import qualified	Factory.Test.QuickCheck.PrimeFactorisation
import qualified	Factory.Test.QuickCheck.Primes
import qualified	Factory.Test.QuickCheck.Probability
import qualified	Factory.Test.QuickCheck.Radix
import qualified	Factory.Test.QuickCheck.SquareRoot
import qualified	Factory.Test.QuickCheck.Statistics
import qualified	Factory.Test.QuickCheck.Summation

-- | Run the /quickChecks/-functions for modules supporting this feature.
run :: IO ()
run	= mapM_ (
	uncurry (>>) . Control.Arrow.first putStrLn
 ) [
	("ArithmeticGeometricMean",	Factory.Test.QuickCheck.ArithmeticGeometricMean.quickChecks),
	("Factorial",			Factory.Test.QuickCheck.Factorial.quickChecks),
	("Hyperoperation",		Factory.Test.QuickCheck.Hyperoperation.quickChecks),
	("Interval",			Factory.Test.QuickCheck.Interval.quickChecks),
	("MonicPolynomial",		Factory.Test.QuickCheck.MonicPolynomial.quickChecks),
	("PerfectPower",		Factory.Test.QuickCheck.PerfectPower.quickChecks),
	("Pi",				Factory.Test.QuickCheck.Pi.quickChecks),
	("Polynomial",			Factory.Test.QuickCheck.Polynomial.quickChecks),
	("Power",			Factory.Test.QuickCheck.Power.quickChecks),
	("Primality",			Factory.Test.QuickCheck.Primality.quickChecks),
	("PrimeFactorisation",		Factory.Test.QuickCheck.PrimeFactorisation.quickChecks),
	("Primes",			Factory.Test.QuickCheck.Primes.quickChecks),
	("Probability",			Factory.Test.QuickCheck.Probability.quickChecks),
	("Radix",			Factory.Test.QuickCheck.Radix.quickChecks),
	("SquareRoot",			Factory.Test.QuickCheck.SquareRoot.quickChecks),
	("Statistics",			Factory.Test.QuickCheck.Statistics.quickChecks),
	("Summation",			Factory.Test.QuickCheck.Summation.quickChecks)
 ]

